Atelier Part

From FreeCAD Documentation
Revision as of 11:58, 20 October 2019 by Mario52 (talk | contribs) (Created page with "{{Caption|Le "Part::TopoShape" est l'objet géométrique visible à l'écran. Essentiellement, tous les ateliers utilisent ces TopoShapes en interne pour créer et afficher de...")
Jump to: navigation, search
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎hrvatski • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎
Arrow-left.svg Page précédente: OpenSCADWorkbench.svg Atelier OpenSCAD
Page suivante: Atelier PartDesign Workbench PartDesign.svg Arrow-right.svg

Workbench Part.svg

Introduction

Les capacités de modélisations de solides de FreeCAD sont basées sur le noyau Open Cascade Technology (OCCT) , un système de CAO de niveau professionnel qui offre une création et une manipulation avancées de la géométrie 3D. L'atelier Part est une couche située au-dessus des bibliothèques OCCT, qui permet à l'utilisateur d'accéder aux primitives et fonctions géométriques OCCT. Toutes les fonctions de dessin 2D et 3D de chaque atelier (Draft, [Sketcher Workbench/fr|Sketcher], PartDesign, etc.), sont basées sur ces fonctions exposées par l'atelier Part. Par conséquent, L'atelier Part est considéré comme le composant central des capacités de modélisation de FreeCAD.

Les objets créés avec l'atelier Part sont relativement simples. ils sont destinés à être utilisés avec des opérations booléennes (unions et coupes) afin de créer des formes plus complexes. Ce paradigme de modélisation est connu sous le nom de [CSG] constructive solid geometry et constitue la méthodologie traditionnelle utilisée dans les premiers systèmes de CAO. D'autre part, l'atelier PartDesign fournit un flux de travail plus moderne pour la construction de formes: il utilise des croquis définis de manière paramétrique, qui sont extrudés pour former un corps solide de base, qui est ensuite modifié par des transformations paramétriques ( édition de fonctions), jusqu'à l'obtention de l'objet final.

Les objets Part sont plus complexes que les objets maillés créés avec les Objets mailles, les objets Part sont plus complexes et permettent donc des opérations plus avancées telles que les opérations booléennes cohérentes, l'historique des modifications et le comportement paramétrique.

Part example.jpg

Part Workbench relationships.svg

L'atelier Part est la couche de base qui expose les fonctions de dessin OCCT à tous les ateliers de FreeCAD.


Les outils

Les outils de l'atelier Part sont situés dans le menu Part qui apparaît lorsque l'on charge l'atelier Part.

Primitives

Ce sont des outils pour créer des objets primitifs.

  • Part Box.png Cube: Dessine un cube en spécifiant ses dimensions.
  • Part Cylinder.png Cylindre: Dessine un cylindre en spécifiant ses dimensions.
  • Part Sphere.png Sphère: Dessine une sphère en spécifiant ses dimensions.
  • Part Cone.png Cône: Dessine un cône en spécifiant ses dimensions.
  • Part Torus.png Tore: Dessine un tore en spécifiant ses dimensions.
  • Part CreatePrimitives.png Création de Primitives: Un outil pour créer diverses primitives géométriques paramétriques.
  • Part Shapebuilder.png Utilitaire de création de formes: Un outil avancé de création de formes plus complexes à partir de diverses primitives géométriques paramétriques.

Modifier les objets

Voici les outils permettant de modifier les objets existants. Ils vous permettront de choisir quels objets modifier.

  • Part Extrude.png Extrusion: Extrude les faces planes d'un objet
  • Part Revolve.png Révolution: Crée un solide en faisant tourner un autre objet (pas un solide) autour d'un axe
  • Part Mirror.png Miroir: Reflète l'objet sélectionné sur un plan de miroir donné
  • Part Fillet.png Congé: Congé (arrondi) le bords d'un objet
  • Part Chamfer.png Chanfrein: Chanfreine les bords d'un objet
  • Part RuledSurface.png Création de surface: Crée une surface réglée
  • Part Loft.png Lissage: Crée une forme lissée d'un profil à un autre
  • Part Sweep.png Balayage: Crée une forme en balayant un ou plusieurs profils le long d'un chemin
  • Part Thickness.png Crée un évidement (coque): Creuse un solide sur la (les) face(s) sélectionnée en laissant les autres parois à une épaisseur déterminée.

Mesure

Std Measure Menu.png Mesure: Permet des mesures linéaires et angulaires entre les points, les arêtes et les faces.

Autres outils

  • Part CheckGeometry.svg Check geometry: Vérifie la géométrie des objets sélectionnés pour en détecter les erreurs.

Préférences

OCCT concepts géométriques

Dans la terminologie OpenCascade, nous faisons la distinction entre les primitives géométriques et les formes (topologiques). Une primitive géométrique peut être un point, une ligne, un cercle, un plan, etc. ou même certains types plus complexes, comme une courbe B-Spline ou une surface. Une forme (shape en anglais) peut être un sommet, une arête, un fil, une face, un solide ou un composé d'autres formes. Les primitives géométriques ne sont pas faites pour être affichées directement sur la scène 3D, mais plutôt pour être utilisées comme géométrie de construction des formes. Par exemple, une arête peut être construite à partir d'une ligne ou d'une partie de cercle.

Pour résumer, les primitives géométriques sont des blocs de construction "informes", et que les formes sont les véritables entités géométriques spatiales construites sur ces blocs.

Pour obtenir une liste complète de tous ces éléments, se référer à la documentation OCC et rechercher Geom_Geometry et TopoDS_Shape. Là, vous pourrez également en savoir plus sur les différences entre les objets géométriques et les formes. À notre grand regret, la documentation OCC n'est malheureusement pas disponible en ligne (vous devez télécharger une archive) et est principalement destiné aux programmeurs et non aux utilisateurs finaux. Mais espérons que vous trouverez suffisamment d'informations pour commencer ici.

Les types géométriques peuvent en fait être divisés en deux groupes principaux: les courbes et les surfaces. Sur les courbes (ligne, cercle, ...) vous pouvez directement créer une arête, sur les surfaces (plan, cylindre, ...) une face peut être construite. Par exemple, la ligne primitive géométrique est illimitée, c'est à dire qu'elle est définie par un vecteur de base et un vecteur directeur tandis que la forme associée (et représentée) doit être quelque chose de limité par un début et de fin. Et un cube - un solide - peut être créée par six plans limités.

En contrepartie, il est également possible, depuis une arête ou une face, de revenir à sa primitive géométrique.

Ainsi, en se basant sur les formes, vous pouvez construire des pièces très complexes ou, dans l'autre sens, extraire tous les sous-formes dont est faite une forme plus complexe.

Part TopoShape relationships.svg

Le "Part::TopoShape" est l'objet géométrique visible à l'écran. Essentiellement, tous les ateliers utilisent ces TopoShapes en interne pour créer et afficher des arêtes, des faces et des solides..


Les scripts

Voir aussi: Part scripts

La structure principale de données utilisée dans l'atelier Pièce est le type de données BRep d'OpenCascade. Presque tous les contenus et les types d'objets de l'atelier Pièce sont maintenant disponibles pour les scripts Python. Cela inclut les primitives géométriques, telles que les lignes (Line) et les cercles (Circle ou Arc), et l'ensemble des TopoShapes, tels que les vertex, arêtes, fils, faces, solides et composés. Pour chacun de ces objets, plusieurs méthodes de création existent, et pour certains d'entre eux, en particulier les TopoShapes, des opérations avancées telles que les opérations booléennes union / soustraction / intersection sont également disponibles. Explorez le contenu de l'atelier Pièce, tel que décrit dans la page Les bases du langage de script de FreeCAD, pour en savoir plus.

L'objet le plus simple pouvant être créé est une Part Feature, qui possède une simple propriété DONNÉESPlacement et des propriétés de base permettant de définir sa couleur et son apparence.

Un autre objet simple utilisé dans les objets géométriques 2D est Part2DObject, qui constitue la base des esquisses et la plupart des éléments Draft.

Exemples

Pour créer un élément ligne, passer à la console Python et taper :

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Passons en revue l'exemple Python ci-dessus étape par étape :

import Part,PartGui
doc=App.newDocument()

charge l'atelier Pièce et crée un nouveau document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

La fonction Line décrit en fait un segment de ligne, d'où le point de départ et le point final.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

Cette commande ajoute un objet de type pièce au document et affecte la représentation de forme du segment de ligne à la propriété 'forme' ('Shape') de l'objet ajouté. Il est important de comprendre ici que nous avons utilisé une primitive géométrique (le Part.LineSegment) pour créer un TopoShape à partir de celle-ci (la méthode toShape()). Seules les formes peuvent être ajoutées au document. Dans FreeCAD, les primitives géométriques sont utilisées comme des "structures de base" pour construire les formes.

doc.recompute()

Mise à jour du document. Cela prépare également la représentation visuelle du nouvel objet pièce.

Notez qu'une Line Segment peut être créée en spécifiant son point de départ et son point final directement dans le constructeur, par ex. Part.LineSegment (point1, point2) ou nous pouvons créer une ligne par défaut et définir ses propriétés après, comme nous l'avons fait ici.

Un cercle peut être créé de la même manière:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Notez qu'une fois encore, nous avons utilisé le cercle (primitive géométrique) pour construire une forme. Nous pouvons bien sûr toujours accéder à notre géométrie de construction par la suite, en faisant:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Ici on prend la forme de notre objet f, puis nous prenons la liste de ses arêtes. Dans ce cas il y aura une seule arête parce que nous avons fait toute la forme à partir d'un cercle unique, c'est pourquoi nous ne prenons que le premier élément de la liste des arêtes, et puis nous récupérons sa courbe. Chaque arête a une courbe, qui est la géométrie primitive, sur laquelle elle est basée.

Rendez-vous sur la page Les scripts de pièces si vous voulez en savoir plus.

Tutoriels

Arrow-left.svg Page précédente: OpenSCADWorkbench.svg Atelier OpenSCAD
Page suivante: Atelier PartDesign Workbench PartDesign.svg Arrow-right.svg